#ifndef lint
static char *sccsid = "@(#)cm.c	1.7 (Davin Milun) 5/23/94";
#endif

/*
 * cm  -- Mail checker for me and other folks.
 * 		Returns a status of one for new mail, zero otherwise.
 * 		-q option supresses output and only affects status.
 * Usage: cm [ -q ] [ name... ]
 * Written by Scott Mesches
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>

#define	TRUE	1
#define	FALSE	0
#define	MAILDIR	"/var/mail"

int QFLAG = FALSE; 
int MEONLY = FALSE;
char *pname = NULL;		/* program's name */
char *prefix = NULL;	/* what to start the sentence with */

# define ARGVAL() (*++(*argv) || (--argc && *++argv))

void Usage(void);
int get_status (char *name);

void
Usage () 
{
	fprintf(stderr, 
"Usage: %s [ -q ] [ user ... ]\n", pname);
	exit(0);
}

int
main (int argc, char *argv[])
{
  int     i, retval=0;
  struct passwd  *user;
  char temp[20];

  /* Get the program's name */
  pname = (pname = strrchr(*argv, '/')) ? ++pname : *argv;
  user = getpwuid (getuid ());	/* get the users name */

  if (argc == 1) {		/* just me */
    if (user == NULL) {		/* argh, your not in the passwd file!! */
      perror (*argv);
      exit (0);
    }
    MEONLY = TRUE;
    prefix ="You have ";
    exit (get_status (user -> pw_name)); /* doit */
  }
  argc--, argv++;
  while (argc > 0 && **argv == '-') /* parse flags */
    switch (*++*argv) {
    case 'q':			/* quiet mode */
      QFLAG = TRUE;
      argc--; argv++;
      break;
    default:			/* display usage info and exit */
      Usage();
      break;
    }
  if (QFLAG && !argc)		/* quiet and just me */
    exit (get_status (user -> pw_name));

  for (i = 0; i < argc; i++) {	/* lot's of names */
    if (!QFLAG) {
      (void) sprintf (temp,"%s has ", argv[i]);
      prefix = temp;
    }
    retval = get_status (argv[i]);
  }
  exit (retval);
}

int
get_status (char *name)
{
  char    path[1024];
  struct stat st;

  (void) sprintf (path, "%s/%s", MAILDIR, name); /* append name to maildir */
  if (stat (path, &st)) {	/* file doesn't exist */
    if (!QFLAG)
      printf ("%sno mail.\n",	/* used to be no mailbox, too many complaints */
	      (!MEONLY) ? prefix : "");
    return (0); 
  } 
  if (!st.st_size) {		/* file of zero size */
    if (!QFLAG)
      printf ("%sno mail.\n", (!MEONLY) ? prefix : "");
  }
  else
    if (st.st_mtime > st.st_atime || /* modified after last access */
	st.st_ctime == st.st_atime) { /* file just created */
      if (!QFLAG)
	printf ("%snew mail.\n",prefix);
      return (1);
    }
    else			/* accessed after last modified */
      if (!QFLAG)
	printf ("%smail.\n",prefix);
  return(0);
}
